package net.wicp.tams.app.duckula.controller.service.cas;

import java.util.List;

import net.wicp.tams.app.duckula.controller.bean.models.SysOrg;
import net.wicp.tams.common.Result;
import net.wicp.tams.common.callback.IConvertValue;

/****
 * 组织相关的服务
 * 
 * @author Administrator
 * 
 */
public interface IOrgService {
	/****
	 * 找到所有组织的树
	 * 
	 * @param i18NConvert
	 * @return
	 */
	public String createOrgTree(IConvertValue i18NConvert);

	/****
	 * 删除组织,如果有子组织不能删除,删除组织要做的动作: 1/删除此组织下所有群组 2/删除此组织下所有职位
	 * 3/把挂到此组织下的用户orgid设置为NULL
	 * 
	 * @param orgid
	 * @return
	 */
	public Result delOrg(Integer orgid);

	/***
	 * 通过orgid得到它所有的祖先节点
	 * 
	 * @param orgid
	 * @return
	 */
	public List<SysOrg> findAncestOrg(long orgid);
}
