package net.wicp.tams.duckula.ops;

import org.apache.tapestry5.http.services.Request;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import net.wicp.tams.common.Conf;
import net.wicp.tams.common.thread.threadlocal.PerThreadValue;
import net.wicp.tams.common.thread.threadlocal.PerthreadManager;

public abstract class WebTools {
	public static <T> Page<T> buildPage(Request request) {
		int page = Integer.parseInt(request.getParameter("page"));
		int rows = Integer.parseInt(request.getParameter("rows"));
		return new Page<T>(page, rows);
	}

	/**
	 * 跳过sql拦截检查，如：在未登陆时没办法拿到拦截数据，需要跳过,单次有效
	 */
	public static void skipSQLInterceptor() {
		PerThreadValue<Boolean> superUserValue = PerthreadManager.getInstance()
				.createValue(Conf.get("common.jdbc.sqlIntercept.superUser"), Boolean.class);
		superUserValue.set(true);
	}
}
